#!/usr/bin/perl -w
# Joris Struyve
 
use strict;
 
my $headerlines = 2;        # number of input lines to skip
my %collapsed;
my @stack;
my $nr;
 
sub remember_stack {
    my ($stack, $count) = @_;
    $collapsed{$stack} += $count;
}
 
foreach (<>) {
    next if $nr++ < $headerlines;
    chomp $_;
 
    if(m/^P#C/) {
        my $strt_schema =  index($_,'"');
        my $end_schema  =  index($_,'"',$strt_schema+1);
        my $schema = substr($_,$strt_schema+1,$end_schema-$strt_schema-1);
 
        my $strt_module =  index($_,'"',$end_schema+1);
        my $end_module  =  index($_,'"',$strt_module+1);
        my $module = substr($_,$strt_module+1,$end_module-$strt_module-1);
 
        my $strt_func =  index($_,'"',$end_module+1);
        my $end_func  =  index($_,'"',$strt_func+1);
        my $func = substr($_,$strt_func+1,$end_func-$strt_func-1);
 
        my $frame = $schema.".".$module.".".$func;
        push @stack,$frame;
#print "pushed $frame\n";
        next;
    }
    if(m/^P#X/) {
        my $count = substr($_,4);
        my $joined = join(";", @stack);
        remember_stack($joined,$count);
#print $joined," :",$count,"\n";
        next;
    }
    if(m/^P#R/) {
        my $po = pop @stack;
#print "popped $po\n";
    }
}
 
foreach my $k (sort { $a cmp $b } keys %collapsed) {
    print "$k $collapsed{$k}\n";
}

